/*Realizado por Modelkitsdeluxe para
 * instructables y tecnicas basicas de modelismo.
 * 
 * En esta primera parte designaremos las librerias,
 * las entradas y las variables.
 */

#include <LiquidCrystal_I2C.h> //librerias de pantalla
#include <Wire.h> //libreria para i2c

LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  

int rele=45; // pin rele
int botonamarillo=51; // pin boton amarillo
int botonverde=53; // pin boton verde
int botonazul=47; //pin boton azul
int botonrojo=49; //pin boton rojo

int potenciometro=A3; //pin potenciometro analogico
int presionentrada=A2; //pin transductor de presion total analogico
int presionsalida=A1; //pin transductor de presion regulada analogico

int pasos=0; //para contar los pasos pasos
int pul=13; //para el control de los pulsos
int dir=12; //para controlar la direccion 

float prdestino=0; //variable para la presion elegida

float psientrada; //variable de la presion de entrada en psi
float barentrada;//variable de la presion de entrada en bar

float psisalida;//variable de la presion de salida en psi
float barsalida;//variable de la presion de salida en psi


float objetivo;//variable para lectura del potenciometro
int lobjetivo;//variable para el mapeado del potenciometro
float probjetivo;//variable para añadir decimales

int accion=0; //variable para parar el motor una vez alcance la presion
/*En esta segunda parte configuraremos los pines,
 * su estado inicial, y escribiremos el saludo que
 * solo se leera una vez.
 */
void setup(){
Serial.begin(9600);//iniciamos el serial
lcd.begin(20,4); //inicializamos el LCD

pinMode (rele, OUTPUT); //designa el pin como salida
pinMode (botonamarillo, INPUT_PULLUP); //desgna el pin como entrada pullup
pinMode (botonverde, INPUT_PULLUP); //desgna el pin como entrada pullup
pinMode (botonazul, INPUT_PULLUP); //desgna el pin como entrada pullup
pinMode (botonrojo, INPUT_PULLUP) ;//desgna el pin como entrada pullup
pinMode (dir, OUTPUT); //designa el pin como salida
pinMode (pul, OUTPUT); //designa el pin como salida

digitalWrite(rele, HIGH); //Apagamos el rele inicialmente
digitalWrite (pul, LOW); //Quitamos lo pulsos inicialmente
digitalWrite (dir,LOW); //Quitamos la direccion inicialmente

lcd.setCursor(5,0); //situamos el cursor el la posición 5 de la linea 0.
lcd.print("Super Air"); //escribimos en LCD
lcd.setCursor(5,1); //cursor enla posicion 5 de la linea 1
lcd.print("Controller"); //escribimos
lcd.setCursor(11,3); //cursor enla posicion 14 de la linea 3
lcd.print("By T.B.M."); //escribimos
delay(1500); //esperamos un segundo y medio
      lcd.clear(); // Borranmos y escribimos las opciones en pantalla
      lcd.setCursor(0,0); 
      lcd.print ("P. Entrada       Bar");
      lcd.setCursor (0,1);
      lcd.print ("P. Regulada      Bar");
      lcd.setCursor (0,2);
      lcd.print (" Seleccione Presion ");
      lcd.setCursor(0,3); 
      lcd.print (" 0.8 "); //modifica el 0.8 para establecer la presion que quieras
      lcd.setCursor (5,3);
      lcd.print (" 1.2 "); //modifica el 1.2 para establecer la presion que quieras
      lcd.setCursor (10,3);
      lcd.print (" 2.0 "); //modifica el 2.0 para establecer la presion que quieras
      lcd.setCursor(15,3); 
      lcd.print ("     "); //aqui aparecera la lectura del potenciometro pasado a bares
}
/*En esta ultima parte, leera los sensores, escribira en la pantalla,  
 * y se ejecutara el programa constantemente.
 */
void loop(){
   
   objetivo = analogRead(potenciometro); //realizar la lectura del potenciometro
   lobjetivo = map(objetivo, 0, 1023, 7, 30); //establece la escala en presion deseada en este caso de 0.7 bares a 3 bares
   probjetivo = lobjetivo/10.0; //pone decimales
   lcd.setCursor (16,3); //coloca el cursor en el hueco previsto para ello
   lcd.print(probjetivo,1); //escribe el resultado con un decimal

   psientrada = 43.5 * (5.0*analogRead(presionentrada)/1023.0 - 0.5); //lectura del transductor simplificada
   barentrada = (psientrada/14.5); //convertimos los psi en bares
   lcd.setCursor (12,0); //coloca el cursor en la presion de entrada
   lcd.print(barentrada,1); //escribe el resultado con un decimal

   psisalida = 37.5 * (5.0*analogRead(presionsalida)/1023.0 - 0.5); //lectura de transductor simplificada
   barsalida = (psisalida/14.5); //convertimos los psi en bares
   lcd.setCursor (12,1); //coloca el cursor en la presion de salida
   lcd.print(barsalida, 1); //escribe el resultado con un decimal
   
  if (digitalRead(botonverde)==LOW){ //si el boton verde se pulsa
      lcd.setCursor(0,3); 
      lcd.print ("[0.8]"); //marcamos con dos corchetes el 0.8
      lcd.setCursor (5,3);
      lcd.print (" 1.2 "); 
      lcd.setCursor (10,3);
      lcd.print (" 2.0 "); 
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=0.8; //establecemos como presion de destino 0.8 en este caso
      accion=1;//activamos accion, pasando de 0 a 1
  }
    if (digitalRead(botonamarillo)==LOW){ //igual que el caso anterior solo que esta vez se establece 1.2 como destino
      lcd.setCursor(0,3); 
      lcd.print (" 0.8 "); 
      lcd.setCursor (5,3);
      lcd.print ("[1.2]"); //marcamos con dos corchetes el 1.2
      lcd.setCursor (10,3);
      lcd.print (" 2.0 ");
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=1.2; //establecemos como presion de destino 1.2 en este caso
      accion=1; //activamos accion, pasando de 0 a 1
  }
    if (digitalRead(botonrojo)==LOW){ //igual que el caso anterior solo que esta vez se establece 2.0 como destino
      lcd.setCursor(0,3); 
      lcd.print (" 0.8 ");
      lcd.setCursor (5,3);
      lcd.print (" 1.2 ");
      lcd.setCursor (10,3);
      lcd.print ("[2.0]");
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=2.0;
      accion=1; //activamos accion, pasando de 0 a 1
  }
    if (digitalRead(botonazul)==LOW){ //igual que el caso anterior solo que esta vez se establece probjetivo como destino

      lcd.setCursor(0,3); 
      lcd.print (" 0.8 ");
      lcd.setCursor (5,3);
      lcd.print (" 1.2 ");
      lcd.setCursor (10,3);
      lcd.print (" 2.0 ");
      lcd.setCursor(15,3); 
      lcd.print ("[   ]");//marcamos con corchetes el hueco donde se escribira la presion objetivo
      prdestino=probjetivo; //la presion objetivo pasa a ser igual a la deseada
      accion=1; //activamos accion, pasando de 0 a 1
  }
   
if(barentrada>prdestino && accion==1){ //si la presion de entrada es mas grande que la establecida en destino y accion esta activado (1) entonces:
   
   if (barsalida < prdestino){gira el motor en direccion del reloj si la presion de destino es mayor

       digitalWrite(dir,LOW); //establecemos direccion izquierda
       digitalWrite(pul,HIGH); //activamos un pulso
       delayMicroseconds(10); //esperamos 10microsengudos
       digitalWrite(pul,LOW); //apagamos el pulso
       delayMicroseconds(10); //esperamos 10microsengudos
       if (barsalida > prdestino-0.01){//Cuando la presion de destino -0.01 sea menor que la de salida
      digitalWrite(dir,LOW); //apagamos direccion
      digitalWrite(pul,LOW); //apagamos pulsos
      lcd.setCursor(0,3); // escribimos todos los recuadros eliminando los corchetes
      lcd.print (" 0.8 "); 
      lcd.setCursor (5,3);
      lcd.print (" 1.2 "); 
      lcd.setCursor (10,3);
      lcd.print (" 2.0 "); 
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=0; //quitamos el valor de la presion de destino
      accion=0; //Paramos el movimiento del motor en uno u otro sentido al pasar accion a 0, condicion indispensable para el movimiento.
       }
   }
   if (barsalida > prdestino){ //gira el motor en direccion del reloj si la presion de destino es menor
        digitalWrite(dir,HIGH); //establecemos direccion derecha
       digitalWrite(pul,HIGH); //activamos un pulso
       delayMicroseconds(10); //esperamos 10microsengudos
       digitalWrite(pul,LOW); //apagamos el pulso
       delayMicroseconds(10); //esperamos 10microsengudos
       pasos++; //sumamos un paso al realizar esta accion una vez
        if (pasos==300){ //a una vuelta suelta libera presion para tomar medidas reales y pone a 0 el contador de pasos
        digitalWrite(rele,LOW); //activa rele
        delay(150); //espera 150 milisegundos
        digitalWrite (rele,HIGH); //apaga el rele
        pasos=0; //pone los pasos a 0
       }
      if (barsalida < prdestino+0.01){//Cuando la presion de destino +0.01 sea m<yor que la de salida
      digitalWrite(dir,LOW); //apagamos direccion
      digitalWrite(pul,LOW); //apagamos pulsos
      lcd.setCursor(0,3); // escribimos todos los recuadros eliminando los corchetes
      lcd.print (" 0.8 "); 
      lcd.setCursor (5,3);
      lcd.print (" 1.2 "); 
      lcd.setCursor (10,3);
      lcd.print (" 2.0 "); 
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=0; //quitamos el valor de la presion de destino
      accion=0; //Paramos el movimiento del motor en uno u otro sentido al pasar accion a 0, condicion indispensable para el movimiento.
       }
    }
  }
}
